VTK: vtkGeoProjection Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkGeoProjection Class Reference

Represent a projection from a sphere to a plane. More...

`#include <vtkGeoProjection.h>`

Inheritance diagram for vtkGeoProjection:
[legend]
Collaboration diagram for vtkGeoProjection:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkGeoProjection * | NewInstance () const
int | GetIndex ()
| Return the index of the current projection's type in the list of all projection types. More...
const char * | GetDescription ()
| Get the description of a projection. More...
projPJ | GetProjection ()
| Return a pointer to the PROJ.4 data structure describing this projection. More...
void | SetOptionalParameter (const char *key, const char *value)
| Add an optional parameter to the projection that will be computed or replace it if already present. More...
void | RemoveOptionalParameter (const char *)
| Remove an optional parameter to the projection that will be computed. More...
int | GetNumberOfOptionalParameters ()
| Return the number of optional parameters. More...
const char * | GetOptionalParameterKey (int index)
| Return the number of optional parameters. More...
const char * | GetOptionalParameterValue (int index)
| Return the number of optional parameters. More...
void | ClearOptionalParameters ()
| Clear all optional parameters. More...
virtual void | SetName (const char *)
| Set/get the short name describing the projection you wish to use. More...
virtual char * | GetName ()
| Set/get the short name describing the projection you wish to use. More...
virtual void | SetCentralMeridian (double)
| Set/get the longitude which corresponds to the central meridian of the projection. More...
virtual double | GetCentralMeridian ()
| Set/get the longitude which corresponds to the central meridian of the projection. More...
virtual void | SetPROJ4String (const char *)
| Set/Get/Clear projection string in PROJ.4 format. More...
virtual char * | GetPROJ4String ()
| Set/Get/Clear projection string in PROJ.4 format. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkGeoProjection * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkGeoProjection * | SafeDownCast (vtkObjectBase *o)
static int | GetNumberOfProjections ()
| Returns the number of projections that this class offers. More...
static const char * | GetProjectionName (int projection)
| Returns the name of one of the projections supported by this class. More...
static const char * | GetProjectionDescription (int projection)
| Returns a description of one of the projections supported by this class. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkGeoProjection ()
| ~vtkGeoProjection () override
virtual int | UpdateProjection ()
| Determine whether the current projection structure has any changes pending and apply them if necessary. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
char * | Name
double | CentralMeridian
projPJ | Projection
vtkMTimeType | ProjectionMTime
char * | PROJ4String
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Represent a projection from a sphere to a plane.

This class uses the PROJ.4 library to represent geographic coordinate projections.

Tests:
  vtkGeoProjection (Tests)

Definition at line 28 of file vtkGeoProjection.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkGeoProjection::Superclass

Definition at line 33 of file vtkGeoProjection.h.

## Constructor & Destructor Documentation

## ◆ vtkGeoProjection()

vtkGeoProjection::vtkGeoProjection | ( |  | ) |
| protected

## ◆ ~vtkGeoProjection()

vtkGeoProjection::~vtkGeoProjection | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkGeoProjection* vtkGeoProjection::New | ( |  | ) |
| static

## ◆ PrintSelf()

void vtkGeoProjection::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ IsTypeOf()

static vtkTypeBool vtkGeoProjection::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkGeoProjection::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkGeoProjection* vtkGeoProjection::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkGeoProjection::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkGeoProjection* vtkGeoProjection::NewInstance | ( |  | ) | const

## ◆ GetNumberOfProjections()

static int vtkGeoProjection::GetNumberOfProjections | ( |  | ) |
| static

Returns the number of projections that this class offers.

## ◆ GetProjectionName()

static const char* vtkGeoProjection::GetProjectionName | ( | int | projection | ) |
| static

Returns the name of one of the projections supported by this class.

You can pass these strings to SetName(char*).

Parameters

  projection | the index of a projection, must be in [0,GetNumberOfProjections()[.

## ◆ GetProjectionDescription()

static const char* vtkGeoProjection::GetProjectionDescription | ( | int | projection | ) |
| static

Returns a description of one of the projections supported by this class.

Parameters

  projection | the index of a projection, must be in [0,GetNumberOfProjections()[.

## ◆ SetName()

virtual void vtkGeoProjection::SetName | ( | const char * |  | ) |
| virtual

Set/get the short name describing the projection you wish to use.

This defaults to "latlong". To get a list of valid values, use the GetNumberOfProjections() and GetProjectionName(int) static methods.

## ◆ GetName()

virtual char* vtkGeoProjection::GetName | ( |  | ) |
| virtual

Set/get the short name describing the projection you wish to use.

This defaults to "latlong". To get a list of valid values, use the GetNumberOfProjections() and GetProjectionName(int) static methods.

## ◆ GetIndex()

int vtkGeoProjection::GetIndex | ( |  | ) |

Return the index of the current projection's type in the list of all projection types.

On error, this will return -1. On success, it returns a number in [0,GetNumberOfProjections()[.

## ◆ GetDescription()

const char* vtkGeoProjection::GetDescription | ( |  | ) |

Get the description of a projection.

This will return nullptr if the projection name is invalid.

## ◆ SetCentralMeridian()

virtual void vtkGeoProjection::SetCentralMeridian | ( | double |  | ) |
| virtual

Set/get the longitude which corresponds to the central meridian of the projection.

This defaults to 0, the Greenwich Meridian.

## ◆ GetCentralMeridian()

virtual double vtkGeoProjection::GetCentralMeridian | ( |  | ) |
| virtual

Set/get the longitude which corresponds to the central meridian of the projection.

This defaults to 0, the Greenwich Meridian.

## ◆ GetProjection()

projPJ vtkGeoProjection::GetProjection | ( |  | ) |

Return a pointer to the PROJ.4 data structure describing this projection.

This may return nullptr if an invalid projection name or parameter set is specified. If you invoke any methods on this vtkGeoProjection object, the PROJ.4 structure this method returns may be freed, so you should not use the PROJ.4 structure after changing any parameters. Also, you should not modify the PROJ.4 structure on your own as it will then be out of sync with the vtkGeoProjection class.

## ◆ SetOptionalParameter()

void vtkGeoProjection::SetOptionalParameter | ( | const char * | key,
|  | const char * | value
| ) |  |

Add an optional parameter to the projection that will be computed or replace it if already present.

## ◆ RemoveOptionalParameter()

void vtkGeoProjection::RemoveOptionalParameter | ( | const char * |  | ) |

Remove an optional parameter to the projection that will be computed.

## ◆ GetNumberOfOptionalParameters()

int vtkGeoProjection::GetNumberOfOptionalParameters | ( |  | ) |

Return the number of optional parameters.

## ◆ GetOptionalParameterKey()

const char* vtkGeoProjection::GetOptionalParameterKey | ( | int | index | ) |

Return the number of optional parameters.

## ◆ GetOptionalParameterValue()

const char* vtkGeoProjection::GetOptionalParameterValue | ( | int | index | ) |

Return the number of optional parameters.

## ◆ ClearOptionalParameters()

void vtkGeoProjection::ClearOptionalParameters | ( |  | ) |

Clear all optional parameters.

## ◆ SetPROJ4String()

virtual void vtkGeoProjection::SetPROJ4String | ( | const char * |  | ) |
| virtual

Set/Get/Clear projection string in PROJ.4 format.

This is a special case alternative to setting the projection name and specifying parameters.

Note
  If the PROJ4String is not empty, it supercedes the other parameters and is used explicitly to instantiate the `projPJ` projection object.

## ◆ GetPROJ4String()

virtual char* vtkGeoProjection::GetPROJ4String | ( |  | ) |
| virtual

Set/Get/Clear projection string in PROJ.4 format.

This is a special case alternative to setting the projection name and specifying parameters.

Note
  If the PROJ4String is not empty, it supercedes the other parameters and is used explicitly to instantiate the `projPJ` projection object.

## ◆ UpdateProjection()

virtual int vtkGeoProjection::UpdateProjection | ( |  | ) |
| protectedvirtual

Determine whether the current projection structure has any changes pending and apply them if necessary.

Upon success, 0 is returned. When an error occurs, a nonzero value is returned.

## Member Data Documentation

## ◆ Name

char* vtkGeoProjection::Name
| protected

Definition at line 151 of file vtkGeoProjection.h.

## ◆ CentralMeridian

double vtkGeoProjection::CentralMeridian
| protected

Definition at line 152 of file vtkGeoProjection.h.

## ◆ Projection

projPJ vtkGeoProjection::Projection
| protected

Definition at line 153 of file vtkGeoProjection.h.

## ◆ ProjectionMTime

vtkMTimeType vtkGeoProjection::ProjectionMTime
| protected

Definition at line 154 of file vtkGeoProjection.h.

## ◆ PROJ4String

char* vtkGeoProjection::PROJ4String
| protected

Definition at line 155 of file vtkGeoProjection.h.

The documentation for this class was generated from the following file:

- Geovis/Core/vtkGeoProjection.h